'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _constants = require('redux-persist/constants');

var _request = require('./request');

exports.default = function (baseAction) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var action = arguments[1];

    switch (action.type) {
      case baseAction:
        return true;
      case _constants.REHYDRATE:
      case (0, _request.successActionType)(baseAction):
      case (0, _request.errorActionType)(baseAction):
        return false;
      default:
        return state;
    }
  };
};