'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchJson = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.waitForOnline = waitForOnline;
exports.getRequest = getRequest;
exports.fetchQueuedRequest = fetchQueuedRequest;

require('core-js/fn/object/values');

var _effects = require('redux-saga/effects');

var _reduxOfflineStatus = require('redux-offline-status');

var _requestQueue = require('../requestQueue/requestQueue.actions');

var _request = require('./request.actions');

var _isNetworkError = require('../isNetworkError');

var _marked = /*#__PURE__*/regeneratorRuntime.mark(waitForOnline),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(getRequest),
    _marked3 = /*#__PURE__*/regeneratorRuntime.mark(fetchQueuedRequest);

function waitForOnline() {
  var offline;
  return regeneratorRuntime.wrap(function waitForOnline$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.select)(_reduxOfflineStatus.isOffline);

        case 2:
          offline = _context.sent;

          if (!offline) {
            _context.next = 7;
            break;
          }

          _context.next = 6;
          return (0, _effects.take)(_reduxOfflineStatus.ONLINE);

        case 6:
          return _context.abrupt('return', _context.sent);

        case 7:
          return _context.abrupt('return', true);

        case 8:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}

function getRequest(apiCall, action) {
  var res;
  return regeneratorRuntime.wrap(function getRequest$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _effects.call)(waitForOnline);

        case 2:
          _context2.prev = 2;
          _context2.next = 5;
          return (0, _effects.call)(apiCall, action.params);

        case 5:
          res = _context2.sent;
          _context2.next = 8;
          return (0, _effects.put)((0, _request.requestSuccess)(action.type, res));

        case 8:
          return _context2.abrupt('return', res);

        case 11:
          _context2.prev = 11;
          _context2.t0 = _context2['catch'](2);

          if (!(0, _isNetworkError.isNetworkError)(_context2.t0)) {
            _context2.next = 19;
            break;
          }

          _context2.next = 16;
          return (0, _effects.put)({ type: _reduxOfflineStatus.OFFLINE });

        case 16:
          _context2.next = 18;
          return (0, _effects.call)(getRequest, apiCall, action);

        case 18:
          return _context2.abrupt('return', _context2.sent);

        case 19:
          _context2.next = 21;
          return (0, _effects.put)((0, _request.requestError)(action.type, _context2.t0));

        case 21:
          return _context2.abrupt('return', new Error(_context2.t0));

        case 22:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked2, this, [[2, 11]]);
}

var fetchJson = exports.fetchJson = function fetchJson(url, method, payload) {
  return fetch(url, {
    method: method,
    credentials: 'include',
    headers: new Headers({ 'content-type': 'application/json' }),
    body: JSON.stringify(payload)
  }).then(function (res) {
    if (res.ok) {
      return res.json();
    }

    throw new Error(res.statusText);
  });
};

function fetchQueuedRequest(action) {
  var type, url, method, payload, res;
  return regeneratorRuntime.wrap(function fetchQueuedRequest$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          type = action.type, url = action.url, method = action.method, payload = action.payload;
          _context3.next = 3;
          return (0, _effects.call)(waitForOnline);

        case 3:
          _context3.prev = 3;
          _context3.next = 6;
          return (0, _effects.call)(fetchJson, url, method, payload);

        case 6:
          res = _context3.sent;
          _context3.next = 9;
          return (0, _effects.put)((0, _request.requestSuccess)(type, _extends({}, res, {
            queued: true,
            parent: action
          })));

        case 9:
          _context3.next = 11;
          return (0, _effects.put)((0, _requestQueue.dequeueRequest)(action.id));

        case 11:
          return _context3.abrupt('return', res);

        case 14:
          _context3.prev = 14;
          _context3.t0 = _context3['catch'](3);

          if (!(0, _isNetworkError.isNetworkError)(_context3.t0)) {
            _context3.next = 21;
            break;
          }

          _context3.next = 19;
          return (0, _effects.put)({ type: _reduxOfflineStatus.OFFLINE });

        case 19:
          _context3.next = 23;
          break;

        case 21:
          _context3.next = 23;
          return (0, _effects.put)((0, _requestQueue.dequeueRequest)(action.id));

        case 23:
          _context3.next = 25;
          return (0, _effects.put)((0, _request.requestError)(type, _context3.t0));

        case 25:
          return _context3.abrupt('return', new Error(_context3.t0));

        case 26:
        case 'end':
          return _context3.stop();
      }
    }
  }, _marked3, this, [[3, 14]]);
}