'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requestQueue = undefined;

var _requestQueue = require('./requestQueue.actions');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var requestQueue = function requestQueue() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var action = arguments[1];

  var type = action.type,
      rest = _objectWithoutProperties(action, ['type']);

  switch (type) {
    case _requestQueue.QUEUE_REQUEST:
      return [].concat(_toConsumableArray(state), [rest]); // TODO: Kill requests with the same ID

    case _requestQueue.DEQUEUE_REQUEST:
      return state.filter(function (request) {
        return request.id !== action.id;
      });

    default:
      return state;
  }
};

exports.requestQueue = requestQueue;
exports.default = requestQueue;